package se.gawell.kvtstore.core;

import java.util.Date;
import java.util.List;

public interface KeyTimeValueStore<PrimaryKeyType> {

	PrimaryKeyType put(Object object, SecondaryIndexValue... indexes);

	void put(PrimaryKeyType primaryKey, Object object, SecondaryIndexValue... indexes);

	<type> type getById(PrimaryKeyType primaryKey, Class<? extends Object> type);

	<type> List<type> getByTimeInterval(Date startOfIntervalInclusive, Date endOfIntervalExclusive, Class<? extends Object> type);

	<type> void delete(PrimaryKeyType primaryKey, Class<? extends Object> type);

	<type> List<type> getByIndex(SecondaryIndexValue index, Class<? extends Object> type);

}
